Loading...
Searching...
No Matches
Opm::Spe5FluidSystem< Scalar > Class Template Reference

The fluid system for the oil, gas and water phases of the SPE5 problem. More...

`#include <Spe5FluidSystem.hpp>`

Inheritance diagram for Opm::Spe5FluidSystem< Scalar >:

## Classes

struct | ParameterCache
| The type of the fluid system's parameter cache. More...

## Public Types

typedef ::Opm::H2O< Scalar > | H2O
| The component for pure water to be used.
Public Types inherited from Opm::BaseFluidSystem< Scalar, Spe5FluidSystem< Scalar > >
typedef Scalar | Scalar
| The type used for scalar quantities.

## Static Public Member Functions

static std::string_view | phaseName (unsigned phaseIdx)
| Return the human readable name of a fluid phase.
static bool | isLiquid (unsigned phaseIdx)
| Return whether a phase is liquid.
static bool | isCompressible (unsigned)
| Returns true if and only if a fluid phase is assumed to be compressible.
static bool | isIdealGas (unsigned)
| Returns true if and only if a fluid phase is assumed to be an ideal gas.
static bool | isIdealMixture (unsigned phaseIdx)
| Returns true if and only if a fluid phase is assumed to be an ideal mixture.
static std::string_view | componentName (unsigned compIdx)
| Return the human readable name of a component.
static Scalar | molarMass (unsigned compIdx)
| Return the molar mass of a component in [kg/mol].
static Scalar | criticalTemperature (unsigned compIdx)
| Critical temperature of a component [K].
static Scalar | criticalPressure (unsigned compIdx)
| Critical pressure of a component [Pa].
static Scalar | criticalMolarVolume (unsigned compIdx)
| Molar volume of a component at the critical point [m^3/mol].
static Scalar | acentricFactor (unsigned compIdx)
| The acentric factor of a component [].
static Scalar | interactionCoefficient (unsigned comp1Idx, unsigned comp2Idx)
| Returns the interaction coefficient for two components.
static void | init (Scalar minT=273.15, Scalar maxT=373.15, Scalar minP=1e4, Scalar maxP=100e6)
| Initialize the fluid system's static parameters.
template<class FluidState, class LhsEval = typename FluidState::Scalar, class ParamCacheEval = LhsEval>
static LhsEval | density (const FluidState &fluidState, const ParameterCache< ParamCacheEval > &paramCache, unsigned phaseIdx)
| Calculate the density [kg/m^3] of a fluid phase.
template<class FluidState, class LhsEval = typename FluidState::Scalar, class ParamCacheEval = LhsEval>
static LhsEval | viscosity (const FluidState &, const ParameterCache< ParamCacheEval > &, unsigned phaseIdx)
| Calculate the dynamic viscosity of a fluid phase [Pa*s].
template<class FluidState, class LhsEval = typename FluidState::Scalar, class ParamCacheEval = LhsEval>
static LhsEval | fugacityCoefficient (const FluidState &fluidState, const ParameterCache< ParamCacheEval > &paramCache, unsigned phaseIdx, unsigned compIdx)
| Calculate the fugacity coefficient [Pa] of an individual component in a fluid phase.
Static Public Member Functions inherited from Opm::BaseFluidSystem< Scalar, Spe5FluidSystem< Scalar > >
static std::string_view | phaseName (unsigned)
| Return the human readable name of a fluid phase.
static bool | isLiquid (unsigned)
| Return whether a phase is liquid.
static bool | isIdealMixture (unsigned)
| Returns true if and only if a fluid phase is assumed to be an ideal mixture.
static bool | isCompressible (unsigned)
| Returns true if and only if a fluid phase is assumed to be compressible.
static bool | isIdealGas (unsigned)
| Returns true if and only if a fluid phase is assumed to be an ideal gas.
static std::string_view | componentName (unsigned)
| Return the human readable name of a component.
static Scalar | molarMass (unsigned)
| Return the molar mass of a component in [kg/mol].
static Scalar | acentricFactor (unsigned)
| Return the acetntric factor of a component.
static void | init ()
| Initialize the fluid system's static parameters.
static LhsEval | density (const FluidState &, const ParamCache &, unsigned)
| Calculate the density [kg/m^3] of a fluid phase.
static LhsEval | fugacityCoefficient (const FluidState &, ParamCache &, unsigned, unsigned)
| Calculate the fugacity coefficient [Pa] of an individual component in a fluid phase.
static LhsEval | viscosity (const FluidState &, ParamCache &, unsigned)
| Calculate the dynamic viscosity of a fluid phase [Pa*s].
static LhsEval | diffusionCoefficient (const FluidState &, ParamCache &, unsigned, unsigned)
| Calculate the binary molecular diffusion coefficient for a component in a fluid phase [mol^2 * s / (kg*m^3)].
static LhsEval | enthalpy (const FluidState &, ParamCache &, unsigned)
| Given a phase's composition, temperature, pressure and density, calculate its specific enthalpy [J/kg].
static LhsEval | thermalConductivity (const FluidState &, ParamCache &, unsigned)
| Thermal conductivity of a fluid phase [W/(m K)].
static LhsEval | heatCapacity (const FluidState &, ParamCache &, unsigned)
| Specific isobaric heat capacity of a fluid phase [J/kg].
static bool | phaseIsActive (unsigned)
| Returns whether a fluid phase is active.

## Static Public Attributes

static const int | numPhases = 3
| Number of fluid phases in the fluid system.
static const int | gasPhaseIdx = 0
| Index of the gas phase.
static const int | waterPhaseIdx = 1
| Index of the water phase.
static const int | oilPhaseIdx = 2
| Index of the oil phase.
static const int | numComponents = 7
| Number of chemical species in the fluid system.
static const int | H2OIdx = 0
| Index of the water component.
static const int | C1Idx = 1
| Index of the C1 component.
static const int | C3Idx = 2
| Index of the C3 component.
static const int | C6Idx = 3
| Index of the C6 component.
static const int | C10Idx = 4
| Index of the C10 component.
static const int | C15Idx = 5
| Index of the C15 component.
static const int | C20Idx = 6
| Index of the C20 component.
Static Public Attributes inherited from Opm::BaseFluidSystem< Scalar, Spe5FluidSystem< Scalar > >
static const int | numComponents
| Number of chemical species in the fluid system.
static const int | numPhases
| Number of fluid phases in the fluid system.

## Static Protected Member Functions

template<class LhsEval>
static LhsEval | henryCoeffWater_ (unsigned compIdx, const LhsEval &temperature)

## Detailed Description

template<class Scalar>
class Opm::Spe5FluidSystem< Scalar >

The fluid system for the oil, gas and water phases of the SPE5 problem.

This problem comprises , , , , , and as components.

See:

J.E. Killough, et al.: Fifth Comparative Solution Project: Evaluation of Miscible Flood Simulators, Ninth SPE Symposium on Reservoir Simulation, 1987

## Member Function Documentation

## componentName()

template<class Scalar>

std::string_view Opm::Spe5FluidSystem< Scalar >::componentName | ( | unsigned | compIdx | ) |

inline static

Return the human readable name of a component.

## density()

template<class Scalar>
template<class FluidState, class LhsEval = typename FluidState::Scalar, class ParamCacheEval = LhsEval>

LhsEval Opm::Spe5FluidSystem< Scalar >::density | ( | const FluidState & | fluidState,
|  | const ParameterCache< ParamCacheEval > & | paramCache,
|  | unsigned | phaseIdx )

inline static

Calculate the density [kg/m^3] of a fluid phase.

## fugacityCoefficient()

template<class Scalar>
template<class FluidState, class LhsEval = typename FluidState::Scalar, class ParamCacheEval = LhsEval>

LhsEval Opm::Spe5FluidSystem< Scalar >::fugacityCoefficient | ( | const FluidState & | fluidState,
|  | const ParameterCache< ParamCacheEval > & | paramCache,
|  | unsigned | phaseIdx,
|  | unsigned | compIdx )

inline static

Calculate the fugacity coefficient [Pa] of an individual component in a fluid phase.

The fugacity coefficient is connected to the fugacity and the component's molarity by means of the relation

## init()

template<class Scalar>

void Opm::Spe5FluidSystem< Scalar >::init | ( | Scalar | minT = 273.15,
|  | Scalar | maxT = 373.15,
|  | Scalar | minP = 1e4,
|  | Scalar | maxP = 100e6 )

inline static

Initialize the fluid system's static parameters.

Parameters

  minT | The minimum temperature possibly encountered during the simulation
  maxT | The maximum temperature possibly encountered during the simulation
  minP | The minimum pressure possibly encountered during the simulation
  maxP | The maximum pressure possibly encountered during the simulation

## interactionCoefficient()

template<class Scalar>

Scalar Opm::Spe5FluidSystem< Scalar >::interactionCoefficient | ( | unsigned | comp1Idx,
|  | unsigned | comp2Idx )

inline static

Returns the interaction coefficient for two components.

The values are given by the SPE5 paper.

## isCompressible()

template<class Scalar>

bool Opm::Spe5FluidSystem< Scalar >::isCompressible | ( | unsigned |  | ) |

inline static

Returns true if and only if a fluid phase is assumed to be compressible.

Compressible means that the partial derivative of the density to the fluid pressure is always larger than zero.

In the SPE-5 problems all fluids are compressible...

## isIdealGas()

template<class Scalar>

bool Opm::Spe5FluidSystem< Scalar >::isIdealGas | ( | unsigned |  | ) |

inline static

Returns true if and only if a fluid phase is assumed to be an ideal gas.

## isIdealMixture()

template<class Scalar>

bool Opm::Spe5FluidSystem< Scalar >::isIdealMixture | ( | unsigned | phaseIdx | ) |

inline static

Returns true if and only if a fluid phase is assumed to be an ideal mixture.

We define an ideal mixture as a fluid phase where the fugacity coefficients of all components times the pressure of the phase are independent on the fluid composition. This assumption is true if Henry's law and Rault's law apply. If you are unsure what this function should return, it is safe to return false. The only damage done will be (slightly) increased computation times in some cases.

## isLiquid()

template<class Scalar>

bool Opm::Spe5FluidSystem< Scalar >::isLiquid | ( | unsigned | phaseIdx | ) |

inline static

Return whether a phase is liquid.

## molarMass()

template<class Scalar>

Scalar Opm::Spe5FluidSystem< Scalar >::molarMass | ( | unsigned | compIdx | ) |

inline static

Return the molar mass of a component in [kg/mol].

## phaseName()

template<class Scalar>

std::string_view Opm::Spe5FluidSystem< Scalar >::phaseName | ( | unsigned | phaseIdx | ) |

inline static

Return the human readable name of a fluid phase.

## viscosity()

template<class Scalar>
template<class FluidState, class LhsEval = typename FluidState::Scalar, class ParamCacheEval = LhsEval>

LhsEval Opm::Spe5FluidSystem< Scalar >::viscosity | ( | const FluidState & | ,
|  | const ParameterCache< ParamCacheEval > & | ,
|  | unsigned | phaseIdx )

inline static

Calculate the dynamic viscosity of a fluid phase [Pa*s].

## Member Data Documentation

## numComponents

template<class Scalar>

const int Opm::Spe5FluidSystem< Scalar >::numComponents = 7

static

Number of chemical species in the fluid system.

## numPhases

template<class Scalar>

const int Opm::Spe5FluidSystem< Scalar >::numPhases = 3

static

Number of fluid phases in the fluid system.

The documentation for this class was generated from the following file:

- opm/material/fluidsystems/Spe5FluidSystem.hpp